function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

import clock from 'clock';
import document from "document";
import { preferences } from "user-settings";
import { FitFont } from 'fitfont';
import { gettext } from "i18n";
var DAYS = ['sunday', 'monday', 'tuesday', 'wednesday', 'thursday', 'friday', 'saturday'];

var CoreElement = /*#__PURE__*/function () {
  function CoreElement(elementId, _ref) {
    var fitfont = _ref.fitfont,
        color = _ref.color;

    _classCallCheck(this, CoreElement);

    try {
      this.id = elementId;

      if (fitfont) {
        this.element = new FitFont(_objectSpread({
          id: elementId
        }, fitfont));
      } else {
        this.element = document.getElementById(elementId);
      }
    } catch (err) {
      console.error(err);
    } // TO-DO: 
    // Decide if we want to continue to keep the
    // fitfont configuration here


    this.fitfont = fitfont || null;

    if (color) {
      this.setColor(color);
    }
  }

  _createClass(CoreElement, [{
    key: "get",
    value: function get() {
      return this.element;
    }
  }, {
    key: "setColor",
    value: function setColor(color) {
      document.getElementById(this.id).style.fill = color;
      this.element.style.fill = color;
    }
  }]);

  return CoreElement;
}(); // Create the Time instance with the id of your element
// by default we assume this is a standard element, but the options can be set
// ** TimeElement ** 
// timeId = 'time'
// options.format = 24h || 12h
// options.fitfont = false || true


export var TimeElement = /*#__PURE__*/function (_CoreElement) {
  _inherits(TimeElement, _CoreElement);

  var _super = _createSuper(TimeElement);

  function TimeElement(_ref2) {
    var _this;

    var timeId = _ref2.timeId,
        fitfont = _ref2.fitfont,
        format = _ref2.format,
        onTick = _ref2.onTick;

    _classCallCheck(this, TimeElement);

    _this = _super.call(this, timeId, {
      fitfont: fitfont
    });
    _this.options = {
      format: format || preferences.clockDisplay,
      type: 'timeElement'
    };

    if (onTick) {
      _this.onTickHandler = onTick;
    }

    return _this;
  }

  _createClass(TimeElement, [{
    key: "deriveTime",
    value: function deriveTime(dateObject) {
      var currentTime = this.options.format === '24h' ? dateObject.getHours() : (dateObject.getHours() + 11) % 12 + 1;
      var hours = ("0" + currentTime).slice(-2);
      var minutes = ("0" + dateObject.getMinutes()).slice(-2);
      return "".concat(hours, ":").concat(minutes);
    }
  }, {
    key: "set",
    value: function set(dateObject) {
      try {
        this.element.text = this.deriveTime(dateObject);
      } catch (err) {
        console.error(err);
      }
    }
  }, {
    key: "onTick",
    value: function onTick(callback) {
      this.onTickHandler = callback;
    }
  }]);

  return TimeElement;
}(CoreElement); // Create a Date instance that can continually update
// ** DateElement **
// dateId = 'date'
// options.fitfont = false || true
// options.i18n = false || true

export var DateElement = /*#__PURE__*/function (_CoreElement2) {
  _inherits(DateElement, _CoreElement2);

  var _super2 = _createSuper(DateElement);

  function DateElement(_ref3) {
    var _this2;

    var dateId = _ref3.dateId,
        fitfont = _ref3.fitfont,
        i18n = _ref3.i18n,
        _ref3$titleCase = _ref3.titleCase,
        titleCase = _ref3$titleCase === void 0 ? true : _ref3$titleCase;

    _classCallCheck(this, DateElement);

    _this2 = _super2.call(this, dateId, {
      fitfont: fitfont
    });
    _this2.options = {
      i18n: i18n || false,
      type: 'dateElement',
      titleCase: titleCase
    };
    return _this2;
  }

  _createClass(DateElement, [{
    key: "updateRequired",
    value: function updateRequired(newDate) {
      return this.shortDate !== newDate.toDateString();
    }
  }, {
    key: "set",
    value: function set(dateObject) {
      this.shortDate = dateObject.toDateString();
      var weekDay = DAYS[dateObject.getDay()];

      if (this.options.i18n) {
        weekDay = gettext(weekDay);
      }

      if (this.options.titleCase) {
        this.element.text = "".concat(weekDay.charAt(0).toUpperCase() + weekDay.substring(1), ", ").concat(dateObject.getDate());
      } else {
        this.element.text = "".concat(weekDay, ", ").concat(dateObject.getDate());
      }
    }
  }]);

  return DateElement;
}(CoreElement);

var _default = /*#__PURE__*/function () {
  function _default(timeConfiguration, dateConfiguration) {
    _classCallCheck(this, _default);

    if (timeConfiguration.dateId) {
      console.error('Core expected timeConfiguration in first parameter, but received dateConfiguration instead. - new Core(timeConfiguration, dateConfiguration)');
    }

    if (dateConfiguration.timeId) {
      console.error('Core expected dateConfiguration in second parameter, but received timeConfiguration instead. - new Core(timeConfiguration, dateConfiguration)');
    }

    var dateElement = new DateElement(dateConfiguration);
    var timeElement = new TimeElement(timeConfiguration);
    this.time = timeElement;
    this.date = dateElement;
  }

  _createClass(_default, [{
    key: "initialize",
    value: function initialize() {
      var _this3 = this;

      console.info('Initializing core...');
      clock.granularity = 'minutes';
      console.info('Configuring time...');
      var currentDateObject = new Date();
      this.time.set(currentDateObject);
      this.date.set(currentDateObject);
      console.info('Configuring tick listener...');
      clock.addEventListener('tick', function (tickEvent) {
        var date = tickEvent.date;

        _this3.time.set(date);

        if (typeof _this3.time.onTickHandler === 'function') {
          _this3.time.onTickHandler(tickEvent);
        } // Update date on date changes


        if (_this3.date.updateRequired(date)) {
          _this3.date.set(date);
        }
      });
    }
  }]);

  return _default;
}();

export { _default as default };